{{***************************************************

A P1V DE2-115 Retromachine DOS v. 0.01 - 2015.02.17
Piotr Kardasz, pik33@o2.pl
MIT license

*****************************************************}}

con


  _clkmode = xtal1+pll16x
  _clkfreq = 114_285_714
  _SD_DO = 20
  _SD_CLK = 21
  _SD_DI = 22
  _SD_CS = 23
  _SD_WP = -1 ' -1 ifnot installed.
  _SD_CD = -1 ' -1 ifnot installed.

obj

  vga           : "vnfg099"
  i2c           : "i2cdrv"
  kbm           : "PS2_HIDEngine"
  fat           : "kyefat_lfn"
  sid           : "SIDcog44-0.95"  


var
byte bufor[80]  'readln string buffer
byte cmd[40]  ' readln string buffer
byte arg1[40]  'readln string buffer
byte arg2[40]  'readln string buffer
byte arg3[40]  'readln string buffer
byte path[40]
byte oldpath[40]
byte buffer2[25]
long buffer3[512]
long prompt

pub demo | cnt2, random, i, j, k,l,m,s,s2,s3,s4,s5,s6,s7,s8,s9,s10,x,y,r,g,b,kx1,kx2,kx3,kx4,kx5,kx6,ky1,ky2,ky3,ky4,ky5,ky6

vga.start

path[0]:="\"
path[1]:=0


fat.FATEngineStart(_SD_DO, _SD_CLK, _SD_DI, _SD_CS, _SD_WP, _SD_CD, -1, -1, -1)  
kbm.start(24,25,26,27,0,1792,1120)
waitcnt(cnt+clkfreq)
kbm.mouseConfiguration(3, 0)
kbm.keyboardConfiguration(0,0)
waitcnt(cnt+clkfreq)

vga.poke($8302B,255) 
s:=sid.getsidsample
vga.audiocmd (s)
vga.setirq(64)


bytefill(@buffer2,0,25)
sid.start
sid.updateRegisters(@buffer2)

i:=0
if kbm.mouseready
  i:=i+1
if kbm.keyboardready
  i:=i+2 
vga.poke($83024,i )

initsound
initsamples

repeat i from $83000 to $8300f     ' clear display registers
  vga.poke(i,0)
repeat i from $84000 to $843FF     ' clear audio buffer
  vga.poke(i,0) 
repeat i from $20000 to $21000     ' clear DL area
  vga.poke(i,0) 

'vga.poke($83000+36,0)              ' switch off leds and hex
vga.poke($83000+37,$FFFFFFFF)
vga.poke($83000+38,$FFFFFFFF)
prompt:=string("C:\>")

beep(0,0,0)
beep(1,0,0)
beep(2,0,0)
beep(3,0,0)
vga.graphics(5)
vga.cls
vga.setgraypallette(0)                ' init pallette 0 with grayscale
vga.setcgapallette(0)                 ' init pallette 0 with cga colors
vga.poke($83000+43,160)
vga.poke($83000+44,224)
'initsprites
vga.initcursor
vga.poke($83003,vga.peek($80000))

vga.setcharmode(1,0,1) 
vga.outtextxy(112,0,string("Mounting SD card. Check SD card, reset your board if this text don't disappear"),1)
i:=fat.mountpartition(0)

\fat.openfile(string("vgafont.def"),"R")
repeat i from 0 to 127
  repeat j from 0 to 15
    k:=fat.readbyte
    if i>32
      vga.poke($81000+16*i+j,k><8)
vga.cls
  
vga.setcharmode(1,0,15)  
vga.writeln(string("P1V Retromachine DOS v. 0.01"))
vga.writeln(string(" "))
vga.write(prompt)

'vga.poke($8300a,$01000100)
'fat.changedirectory(string("wav"))

repeat
  readln
  getcmd
  
  if strcomp(@cmd,string("cls"))
    vga.cls
  elseif strcomp(@cmd,string("ver"))
    vga.writeln(string("P1V Retromachine DOS v. 0.01"))
  elseif strcomp(@cmd,string("pwd"))
    i:=fat.getdir
    vga.writeln(i)
  elseif strcomp(@cmd,string("playsid"))
    playsid(@arg1)
  elseif strcomp(@cmd,string("playwav"))
    playwav(@arg1)
  elseif strcomp(@cmd,string("cd"))
    \fat.changedirectory(@arg1)
    if fat.geterror
        vga.write(string("No such directory: "))
        vga.writeln(@arg1)
        fat.reseterror
    else

      l:=strsize(@path)
      m:=strsize(@arg1)

      if strcomp(@arg1,string(".."))
         bytemove(@path,@oldpath,40)

      elseif strcomp(@arg1,string("."))
         l:=m 
      else
        bytemove(@oldpath,@path,40)     
        repeat i from 0 to m
          path[l+i]:=arg1[i]
        path[l+m]:="\"
        path[l+m+1]:=0
        
  elseif strcomp(@cmd,string("color"))
    if (arg1[0]>0) and (arg2[0]>0)
      i:=vga.strtoint(@arg1)
      j:=vga.strtoint(@arg2)
      if (i=>0) and (i<16) and (j=>0) and (j<16)
        vga.setcharmode(1,j,i)
      else
        vga.writeln(string("Invalid arguments"))
    else      
      vga.writeln(string("Invalid arguments"))   
   
  elseif strcomp(@cmd,string("dir"))
    dir  
  else
    if cmd[0]<>0
      \fat.bootpartition(@cmd)
      if fat.geterror
        vga.write(string("Unknown command: "))
        vga.writeln(@cmd)
        fat.reseterror
   
  vga.writeln(string(" "))
  vga.write(string("C:"))
  vga.write(@path)
  if strsize(@path)>1
    vga.bksp
  vga.write(string(">"))
      
'  vga.writeln(string(" "))
'  vga.writeln(@bufor)



pub  dir|i,buffer,c,freq,l,m,n,w

i:=3
vga.write(string(" Directory of C:"))
vga.write(@path)
if strsize(@path)>1
  vga.bksp
vga.writeln(string(" "))   
vga.writeln(string(" "))
fat.listEntries("W")
repeat while(buffer := \fat.listEntries("N"))
  i:=i+1
  vga.write(vga.inttostr(fat.listmodificationyear))
  vga.putc(".")
  if fat.listmodificationmonth<10
     vga.putc("0") 
  vga.write(vga.inttostr(fat.listmodificationmonth))
  vga.putc(".")    
  if fat.listmodificationday<10
     vga.putc("0") 
  vga.write(vga.inttostr(fat.listmodificationday))

  vga.putc(32)

  if fat.listmodificationhours<10
   vga.putc("0") 
  vga.write(vga.inttostr(fat.listmodificationhours))
  vga.putc(".")    
  if fat.listmodificationminutes<10
     vga.putc("0") 
  vga.write(vga.inttostr(fat.listmodificationminutes))

  vga.putc(32) 
      
  vga.write(vga.inttostr2(fat.listsize))
  vga.write(string(" "))
  if fat.listIsDirectory
    vga.write(string("<DIR> "))
  else
    vga.write(string("      "))         

  if fat.islfn
     vga.write(fat.getlfn)                       
     
  else
      vga.write(buffer) 
  vga.writeln(string(" "))
  if i==31
    vga.write(string("--- more ---"))
      if kbm.keyboardeventnumber
        c:=kbm.keyboardevent
         if c==$2843 or c==$2863
           quit    
    i:=0
    c:=0
    repeat
      if kbm.keyboardeventnumber
        c:=kbm.keyboardevent &$28FF
        kbm.keyboardeventsflush
    until c&$7F==32 or c&$7F==13 or c==$2843 or c==$2863
    if c==$2843 or c==$2863
       vga.setcursorx(0)  
       quit  
    vga.setcursorx(0)                                               
i:=fat.partitionFreeSectorCount("F")    
vga.write(vga.inttostr2(i/2))
vga.writeln(string(" kilobytes free"))    

pub read  |i,j

repeat i from 0 to 79
  bufor[i]:=0
i:=0
j:=0 
repeat  
  if kbm.keyboardeventnumber
    j:=kbm.keyboardevent
'    vga.writeln(vga.hextostr(j))
    if j&$800<>0
      if j==$808 'bksp
        if i>0
          i-=1
          bufor[i]:=0
          vga.bksp
      if (j&$FF<127) and (j&$FF>31)
        vga.putc(j&127)
        bufor[i]:=j&127
        i:=i+1
until (j&$87F==$80D) or (i==78)
kbm.keyboardeventsflush
         

pub readln

read
vga.newline

pub getcmd   |i,j


repeat i from 0 to 39
  cmd[i]:=0
  arg1[i]:=0
  arg2[i]:=0
  arg3[i]:=0
i:=0
j:=0   
repeat
  if bufor[i]==0
    quit
  if bufor[i]<>32
    quit
  i:=i+1
repeat
  if bufor[i]==0
    quit
  if bufor[i]==32
    quit
  cmd[j]:=bufor[i]
  i:=i+1
  j:=j+1
cmd[j]:=0
j:=0
repeat
  if bufor[i]==0
    quit
  if bufor[i]<>32
    quit
  i:=i+1
repeat
  if bufor[i]==0
    quit
  if bufor[i]==32
    quit
  if bufor[i]==","
    quit  
  arg1[j]:=bufor[i]
  i:=i+1
  j:=j+1
arg1[j]:=0    
j:=0
repeat
  if bufor[i]==0
    quit
  if (bufor[i]<>32) and (bufor[i]<>",")
    quit
  i:=i+1
repeat
  if bufor[i]==0
    quit
  if bufor[i]==32
    quit
  if bufor[i]==","
    quit  
  arg2[j]:=bufor[i]
  i:=i+1
  j:=j+1
 arg2[j]:=0    
             
j:=0
repeat
  if bufor[i]==0
    quit
  if (bufor[i]<>32) and (bufor[i]<>",")
    quit
  i:=i+1
repeat
  if bufor[i]==0
    quit
  if bufor[i]==32
    quit
  if bufor[i]==","
    quit  
  arg3[j]:=bufor[i]
  i:=i+1
  j:=j+1
 arg3[j]:=0


pub playsid(name)  |wait,ss,qq,xx,yy,xxd,yyd,c,w

kbm.keyboardeventsflush
\fat.openfile(name,"R")
if fat.geterror==0
  vga.write(string("Playing file "))
  vga.write(name)
  vga.write(string(" - press Ctrl-C to stop"))
  wait:=cnt+clkfreq/50
  repeat
    ss:=vga.peek($83000+39)&7
    if ss==0
      qq:=50
      vga.poke($83000+37,%11111111_11111111_10010010_11000000)
    if ss==1
      qq:=100
      vga.poke($83000+37,%11111111_11111001_11000000_11000000)     
    if ss==2
      qq:=150
      vga.poke($83000+37,%11111111_11111001_10010010_11000000)     
    if ss==4
      qq:=200
      vga.poke($83000+37,%11111111_10100100_11000000_11000000)   
      
    w:=clkfreq/qq


    if kbm.keyboardeventnumber
      xx:=kbm.keyboardevent&$28FF
       
    c:=fat.readdata(@buffer2,25)    
'    if wait>cnt
    waitcnt(wait)  
    wait:=wait+w
    sid.updateRegisters(@buffer2)
  until (c<>25) or xx==$2843 or xx==$2863 
  fat.closefile
  bytefill(@buffer2,0,25)
  sid.updateRegisters(@buffer2)
  kbm.keyboardeventsflush
  vga.writeln(string(" "))    
else
  fat.reseterror
  vga.write(string("Error - file "))
  vga.write(name)
  vga.writeln(string(" not found"))
    
pub playwav(name)  |c,xx,i

kbm.keyboardeventsflush
\fat.openfile(name,"R")
if fat.geterror==0
  vga.write(string("Playing file "))
  vga.write(name)
  vga.write(string(" - press Ctrl-C to stop"))

  repeat
    c:=\fat.readdata(@buffer3,2048)
    repeat
    until ina[4]==1
    vga.blit2(@buffer3,$84000,512)
    if kbm.keyboardeventnumber
       xx:=kbm.keyboardevent&$28FF

    c:=\fat.readdata(@buffer3,2048)
    repeat
    until ina[4]==0
    vga.blit2(@buffer3,$84200,512)
  until c<>2048   or xx==$2843 or xx==$2863 
  fat.closefile
  repeat i from $84000 to $843ff
    vga.poke(i,0)
else
  fat.reseterror
  vga.write(string("Error - file "))
  vga.write(name)
  vga.writeln(string(" not found"))

  
pub initsound

i2c.start(18)
i2c.write(18,$34)
i2c.write(18,$12)
i2c.write(18,$0)
i2c.stop(18)

i2c.start(18)
i2c.write(18,$34)
i2c.write(18,1)
i2c.write(18,$1f)
i2c.stop(18)

i2c.start(18)
i2c.write(18,$34)
i2c.write(18,$8)
i2c.write(18,$12)
i2c.stop(18)

i2c.start(18)
i2c.write(18,$34)
i2c.write(18,$0a)
i2c.write(18,$0)
i2c.stop(18)

i2c.start(18)
i2c.write(18,$34)
i2c.write(18,$0c)
i2c.write(18,$62)
i2c.stop(18)

i2c.start(18)
i2c.write(18,$34)
i2c.write(18,$0e)
i2c.write(18,$1b)
i2c.stop(18)

i2c.start(18)
i2c.write(18,$34)
i2c.write(18,$10)
i2c.write(18,$22)
i2c.stop(18)

i2c.start(18)
i2c.write(18,$34)
i2c.write(18,$6)
i2c.write(18,$78)
i2c.stop(18)

i2c.start(18)
i2c.write(18,$34)
i2c.write(18,$4)
i2c.write(18,$78)
i2c.stop(18)

i2c.start(18)
i2c.write(18,$34)
i2c.write(18,$12)
i2c.write(18,$1)
i2c.stop(18)   


pub beep(channel, freq, vol)

freq:=freq*23777
freq:=freq/1000
vga.poke($83000+20+channel,freq)
vga.poke($83000+32+channel,vol)  


pub fire(channel,div)   |i,j

'*** Make a demo sound

vga.poke($83000+32+channel,10000+(10000<<16))  
vga.poke($83000+24+channel,$60000)
vga.poke($83000+28+channel,512)                                                                                                      

repeat j from 30 to 150 step 3
  repeat i from 4096 to 180000 step j
   vga.poke($83000+20+channel,i>>div)

vga.poke($83000+32+channel,0)
vga.poke($83010+channel,0)


pub initsamples   |i            

'*** pokes a triangle wave samples, 256 longs from $60000

repeat i from 0 to 127
  vga.poke($60000+i,((128+i)<<8)+((128+i)<<24))
  vga.poke($601FF-i,((128+i)<<8)+((128+i)<<24))
repeat i from 0 to 127
  vga.poke($60080+i,(i<<8)+(i<<24))
  vga.poke($6017F-i,(i<<8)+(i<<24))
vga.poke ($60000,$80008000)
vga.poke ($60200,$80008000)

'******************************** End of demo ************************************************************************
'*********************************************************************************************************************